Bug 1004427 - python-dns: random number generator lacks fork protection
python-dns: random number generator lacks fork protection
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: python-dns (Show other bugs)
25
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jeffrey C. Ollie
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 1004424
  Show dependency treegraph
 
Reported: 2013-09-04 11:33 EDT by Florian Weimer
Modified: 2016-11-19 16:00 EST (History)
4 users (show)

See Also:
Fixed In Version: python-dns-1.15.0-1.fc24 python-dns-1.15.0-1.fc25
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-11-11 15:51:23 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Florian Weimer 2013-09-04 11:33:45 EDT
The random number generator in dns/entropy.py does not clear the pool after a fork.  Parent and child will obtain the same sequence of random numbers as a result.  Reading directly from /dev/urandom probably offers sufficient performance for this application.  (Unfortunately, Python's ssl module does not expose the RAND_bytes function.)
Comment 2 Jaroslav Reznik 2015-03-03 10:02:14 EST
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22
Comment 3 Fedora End Of Life 2016-07-19 06:20:58 EDT
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Florian Weimer 2016-07-21 10:10:58 EDT
It should be sufficient to switch to os.urandom as the random number generator.
Comment 5 Jan Kurik 2016-07-26 00:23:35 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.
Comment 6 Avram Lubkin 2016-08-04 09:24:01 EDT
Upstream switched to using random.SystemRandom as the primary source for random numbers [1] and retained the existing entropy pool as a fallback. I'm not sure when a fallback would be needed since random is included in the standard library. In the fallback, a pid check was added so the pool is reseeded if the pid changes [2].

Will be included in Fedora after the next upstream release. Upstream recently merged Python 2 and Python 3 codebases, and has been working through bugs and cleaning up pylint errors.


[1] https://github.com/rthalley/dnspython/commit/52e95798b4fe36e393ca7a90678f12ff0233c96a

[2] https://github.com/rthalley/dnspython/commit/6a6d2af0dcc94867f6b518d453aeaa7c05fb3352
Comment 7 Fedora Update System 2016-10-09 08:29:22 EDT
python-dns-1.15.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-4998c59ba3
Comment 8 Fedora Update System 2016-10-09 09:50:45 EDT
python-dns-1.15.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-1857421df6
Comment 9 Fedora Update System 2016-11-11 15:51:23 EST
python-dns-1.15.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 10 Fedora Update System 2016-11-19 16:00:50 EST
python-dns-1.15.0-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.